<?php
/**
 * Plugin Name: Nearby Photos
 * Plugin URI: http://runtrails.com/mymountaintrail/nearby-photos-widget-for-wordpress/ 
 * Description: A widget that loads interesting photos taken near your current location and geotagged on Flickr.  Your location is calculated using Loki.com's API and Skyhook Wireless's database of wi-fi network locations.  The widget includes additional Flickr configuration options.
 * Version: 0.9
 * Author: Dan Capshaw
 * Author URI: http://runtrails.com/mymountaintrail/
 * This widget interface is based on the example created by Justin Tadlock.  Justin does not have a specific
 * copyright in his code, but it is his and here are the details:
 * * ******************************Plugin Name: Example Widget
 * ********************************Plugin URI: http://example.com/widget
 * ********************************Description: A widget that serves as an example for developing more advanced widgets.
 * ********************************Version: 0.1
 * ********************************Author: Justin Tadlock
 * ********************************Author URI: http://justintadlock.com

 *
 /// Copyright 2010 Dan Capshaw
//
//    This file is part of the Nearby Photos Widget.
//
//    The Nearby Photos Widget is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    The Nearby Photos Widget is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with The Nearby Photos Widget.  If not, see <http://www.gnu.org/licenses/>.
 */


add_action( 'widgets_init', 'nearby_photo_load_widgets' );


function nearby_photo_load_widgets() {
	register_widget( 'Nearby_Photos_Widget' );
}

class Nearby_Photos_Widget extends WP_Widget {

	function Nearby_Photos_Widget() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'nearbyphotos', 'description' => __('A widget that loads nearby photos from Flickr using Loki.com data.', 'nearbyphotos') );

		/* Widget control settings. */
		$control_ops = array( 'width' => 300, 'height' => 800, 'id_base' => 'nearby-photos-widget' );

		/* Create the widget. */
		$this->WP_Widget( 'nearby-photos-widget', __('Nearby Photos', 'nearbyphotos'), $widget_ops, $control_ops );
	}

	function widget( $args, $instance ) {
		extract( $args );

		/* Our variables from the widget settings. */
		$title = apply_filters('widget_title', $instance['title'] );
		$longitude = $instance['longitude'];
		$latitude = $instance['latitude'];
		$radius = $instance['radius'];
		$photonumber = $instance['photonumber'];
		$start_days = $instance['start_days'];
		$flickr_key = $instance['flickr_key'];
		$loki_key = $instance['loki_key'];
			
		echo $before_widget;
				
		if ( $title )
			echo $before_title . $title . $after_title;
		if ( $longitude )
			printf( '<p id="'. $widget_id . '-lonlat">' . __('Longitude: %1$s', 'nearbyphotos'), $longitude );
		else {echo '<p>No Longitude available.  It is ' . $longitude .'</p>';}
		if ( $latitude )
			printf( ', ' . __('Latitude: %1$s', 'nearbyphotos.') . '</p>', $latitude );
		//if ( $radius )
		//	printf( '<p>' . __('Radius: %1$s km', 'nearbyphotos.') . '</p>', $radius );
		
		$start_date= date('Y-m-d',time()-($start_days*60*60*24));
		
		//Set up and call the javascript code

			echo '<script type="text/javascript" src="http://loki.com/plugin/files/loki.js"></script>';
			echo '<script src= "'. get_option('siteurl'). '/wp-includes/js/jquery/jquery.js" type="text/javascript"></script>';
			echo '<script src = "' . get_option('siteurl') . '/wp-content/plugins/nearby-flickr-photos/nearbyPhotosWidget.js" type = "text/javascript"></script>';
			if(!$start_date) {$start_date= date('Y-m-d',time()-(30*60*60*24));}  //Creates a limited search for Flickr in the event of no date given.
?>
			<script type = "text/javascript">
			
				<!-- // Grab the PHP variables and make them available to javascript.
				<?php 
					echo ("var defaultPhotoslongitude = $longitude;");
					echo ("var defaultPhotoslatitude = $latitude;");
					echo ("var defaultPhotosphotonumber = $photonumber;");
					echo ("var defaultPhotosradius = $radius;");
					echo ("var defaultPhotosstart_date = \"$start_date\";");
					echo ("var defaultPhotoswidget_id = \"$widget_id\";");
					echo ("var defaultPhotosflickr_key = \"$flickr_key\";");
					echo ("var defaultPhotosloki_key = \"$loki_key\";");
				?>
				// -->
				jQuery(document).ready(function(){
				var defaultPhotos = Object.create(nearbyPhotosWidget); 	
					defaultPhotos.nearbyPhotos(defaultPhotoslatitude, defaultPhotoslongitude, defaultPhotosphotonumber,defaultPhotosradius, defaultPhotosstart_date);
				});
			</script>
			<?php 
			
			echo'<div id="'. $widget_id . '-div"></div>';   //create the div for the pictures that can be replaced w/ javascript
			echo '<p><a onclick="nPW = Object.create(nearbyPhotosWidget); nPW.getLocalPhotos(' . $photonumber . ', ' . $radius . ' , \'' . $start_date . '\')" >Click for local photos</a><a href="http://www.loki.com" target="_blank"><img src="' . get_option('siteurl') . '/wp-content/plugins/nearby-flickr-photos/lokilogo.png" alt="Powered by Loki.com" title="Powered by Loki.com" class="alignright" /></a></p>';
			
		//Ende of the javascript setup	
		
		echo $after_widget;
	}

	/**
	 * Update the widget settings.
	 */
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;

		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['longitude'] = strip_tags( $new_instance['longitude'] );
		$instance['latitude'] = strip_tags($new_instance['latitude']);
		$instance['radius'] = strip_tags($new_instance['radius']);
		$instance['photonumber'] = strip_tags($new_instance['photonumber']);
		$instance['start_days'] = strip_tags($new_instance['start_days']);
		$instance['flickr_key'] = strip_tags($new_instance['flickr_key']);
		$instance['loki_key'] = strip_tags($new_instance['loki_key']);

		return $instance;
	}

	/**
	 * Displays the widget settings controls on the widget panel.
	 * Make use of the get_field_id() and get_field_name() function
	 * when creating your form elements. This handles the confusing stuff.
	 */
	function form( $instance ) {
		
		/* Set up some default widget settings. */
		$defaults = array( 'title' => __('Nearby Photos', 'nearbyphotos'), 'latitude' => __('37.9', 'nearbyphotos'), 'longitude' => __('-122.59', 'nearbyphotos'), 'radius' => __('10', 'nearbyphotos'),'photonumber' => __('10', 'nearbyphotos'), 'start_days' => __('14', 'nearbyphotos'), 'flickr_key' => __('Get this from http://www.flickr.com/services/apps/create/apply/', 'nearbyphotos'), 'loki_key' => __('Get this from http://www.loki.com/how/register', 'nearbyphotos'));
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>

		<!-- Widget Title: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e('Title:', 'hybrid'); ?></label>
			<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo $instance['title']; ?>" style="width:100%;" />
		</p>

		
		<!--  Longitude -->
		<p>
			<label for="<?php echo $this->get_field_id( 'longitude' ); ?>"><?php _e('Longitude:', 'nearbyphotos'); ?></label> 
			<input id="<?php echo $this->get_field_id( 'longitude' ); ?>" name="<?php echo $this->get_field_name( 'longitude' ); ?>" value="<?php echo $instance['longitude']; ?>" style="width:100%;" />
	
		</p>
		<!-- Latitude -->
		<p>
			<label for="<?php echo $this->get_field_id( 'latitude' ); ?>"><?php _e('Latitude:', 'nearbyphotos'); ?></label> 
			<input id="<?php echo $this->get_field_id( 'latitude' ); ?>" name="<?php echo $this->get_field_name( 'latitude' ); ?>" value="<?php echo $instance['latitude']; ?>" style="width:100%;" />
	
		</p>
		<!-- Radius -->
		<p>
			<label for="<?php echo $this->get_field_id( 'radius' ); ?>"><?php _e('Radius (KM):', 'nearbyphotos'); ?></label> 
			<input id="<?php echo $this->get_field_id( 'radius' ); ?>" name="<?php echo $this->get_field_name( 'radius' ); ?>" value="<?php echo $instance['radius']; ?>" style="width:100%;" />
	
		</p>
		<!-- Number of Photos -->
		<p>
			<label for="<?php echo $this->get_field_id( 'photonumber' ); ?>"><?php _e('Number of Photos:', 'nearbyphotos'); ?></label> 
			<input id="<?php echo $this->get_field_id( 'photonumber' ); ?>" name="<?php echo $this->get_field_name( 'photonumber' ); ?>" value="<?php echo $instance['photonumber']; ?>" style="width:100%;" />
	
		</p>

		<!-- Start Date -->
		<p>
			<label for="<?php echo $this->get_field_id( 'start_days' ); ?>"><?php _e('Search for photos taken within the last ? days:', 'nearbyphotos'); ?></label> 
			<input id="<?php echo $this->get_field_id( 'start_days' ); ?>" name="<?php echo $this->get_field_name( 'start_days' ); ?>" value="<?php echo $instance['start_days']; ?>" style="width:100%;" />
	
		</p>
		
	<!-- Flickr Key -->
		<p>
			<label for="<?php echo $this->get_field_id( 'flickr_key' ); ?>"><?php _e('Your Flickr API Key:', 'nearbyphotos'); ?></label> 
			<input id="<?php echo $this->get_field_id( 'flickr_key' ); ?>" name="<?php echo $this->get_field_name( 'flickr_key' ); ?>" value="<?php echo $instance['flickr_key']; ?>" style="width:100%;" />
	
		</p>
    
    <!-- Loki Key -->
		<p>
			<label for="<?php echo $this->get_field_id( 'loki_key' ); ?>"><?php _e('Your Loki API Key:', 'nearbyphotos'); ?></label> 
			<input id="<?php echo $this->get_field_id( 'loki_key' ); ?>" name="<?php echo $this->get_field_name( 'loki_key' ); ?>" value="<?php echo $instance['loki_key']; ?>" style="width:100%;" />
	
		</p>
                  
	<?php
	}
}

?>